include \masm32\include\masm32rt.inc
include vararg.inc
RetEax = 1	; raw proc size 14 without returning eax; 22 with return value

.code
s1	db "String 1", 0
s2	db "String 2", 0
s3	db "String 3", 0
s4	db "String 4", 0
start:	mov ebx, esp	; test for stack and/or basepage
	mov esi, ebp	; corruption
	print "Passing a variable # of args with STDCALL:"
	vinv TestVarArgB, offset s1, offset s2, offset s3, offset s4
	if RetEax
		print str$(eax), " args passed", 13, 10
	endif
	vinv TestVarArgB, offset s1, offset s2, offset s3
	if RetEax
		print str$(eax), " args passed", 13, 10
	endif

	.if esp!=ebx || esi!=ebp
		sub eax, esp
		MsgBox 0, str$(eax), "Stack or basepage corruption:", MB_OK
	.endif
	SizeCheck = 0
	if SizeCheck
		print "Size of proc="
		mov eax, TestVarArgB_END
		sub eax, TestVarArgB_S
		print str$(eax), " bytes", 13, 10
	endif
	exit

TestVarArgB_S:
TestVarArgB proc	; NAKED proc, NO USES, NO ARGS!
vloc d1, d2:DWORD, r3:RECT, qw4:QWORD, ow5:OWORD, r4:REAL4
  if SizeCheck ne 1
	; movdqu xmm0, ow5	; from ml v6.15 onwards
	push 123456789
	fild dword ptr [esp]	; move an immediate to a qword using the FPU
		fst r4
	fistp qw4	; assembles fine
	pop eax
		mov d1, 123
		mov d2, 456
		mov r3.left, 789
		mov ebx, vargct
	print chr$(13, 10)	; the simplest usage, a repeat loop with vargr(reg32):

	.Repeat
		print vargr(ebx), 13, 10	; vargREV or vargREG: print next arg (counting down restores correct order)
		dec ebx
	.Until Zero?

	print "local var 1/2/3="
	print str$(d1), "/"
	print str$(d2), "/"
	print str$(r3.left), 9
	print vargi(2), 13, 10	; vargIMM: show arg #2
	mov edx, vargct
  endif
	vret edx
TestVarArgB endp

TestVarArgB_END:

end start

OPT_Assembler	mlv615
OPT_Tmp2Asm	1
OPT_ErrLine	0
